const version = null
const hash = "xxx"

const staticCacheName = version + '_staticFiles'
const pageCacheName = 'pages'
const imgCacheName = 'images'
const webfontCacheName = 'webfonts'
const consoleLogNumber = 1


const urlsToPrefetch = [
  '',
'',
];

const fetchCdn = async (cache, urlsToPrefetch) => {
  for (let index = 0; index < urlsToPrefetch.length; index++) {
    const reqUrl = await new Request(urlsToPrefetch[index], { mode: 'no-cors' })
    fetch(reqUrl).then(response => cache.put(reqUrl, response));
  }
}

const cacheFiles = async _ => {
  const cache = await caches.open(staticCacheName)

  if (null === '1') console.log('👷🏻‍♀️ CacheVersionControl ',staticCacheName)
  if (null === '0') await cache.addAll(['/plugins/system/mittpwa/offline.html',
'',])
  if (null === '1') await fetchCdn(cache, urlsToPrefetch)
}

const cleanCacheVersion = async _ => {
  try {
  const cacheKeys = await self.caches.keys()
  const toDelete = cacheKeys.filter((key) => key !== staticCacheName)
  return Promise.all(toDelete.map((key) => {

    if (null === '1') console.log('cacheKeyDelete ✅', key)
    self.caches.delete(key)
    })
  )
  } catch (error){
    console.log('cacheDeleteError 🚫', error)
  }
}

const cacheMatch = async (request) => {
  try {
    const url = request.url
    const cleanUrl = url.split('?')
    const cacheMatch = await caches.match(cleanUrl[0])
    if (cacheMatch) {
      return cacheMatch
    }
    //avoid admin error page
    if (request.mode === 'navigate' && request.url.includes('administrator')) {
      return
    }
    return false 
  } catch (error) {
    console.log('chacheMatch', error)
  }
}


const uriExceptions = (uri, response) => {
  return new Promise((resolve, reject) => {
    const urlCacheExceptions = ['administrator',]
    let exception
    urlCacheExceptions.forEach(urlCacheException => {
      if (uri.includes(urlCacheException)) {
        exception = true
      }   
    }) 
    !exception
      ? resolve('please clone')
      : reject(new Error('uriException', 'This page wont be cloned to cache' ))
  })
}

const respondTo = async(e) => {
  try {
    // If Post Request load from network
    if (e.request.method !== 'GET' && e.request.ok) {

      if (null === '1') console.log('early Returned Post Request')

      return e.request
    }

    let cacheFirst = null
    const settedNetwork = parseInt(null)
    
    const connection = navigator.connection || navigator.mozConnection || navigator.webkitConnection;
    if (null === '1') console.log('connection', connection)
 
   const effectiveNetwork = (!connection) ?'4g' : connection.effectiveType
    if (null === '1') console.log('effectiveNetworkConnection', effectiveNetwork)
    

    const chacheFirstNetwork = (effectiveNetwork, settedNetwork) => {
      let numberNetwork
      if (effectiveNetwork === '4g') numberNetwork = 4
      if (effectiveNetwork === '3g') numberNetwork = 3
      if (effectiveNetwork === '2g') numberNetwork = 2
      if (effectiveNetwork === 'slow-2g') numberNetwork = 1
      
      if (settedNetwork >= numberNetwork) {
        if (null === '1') console.log('chacheFirsteffectiveNetwork', '1')
        return cacheFirst = '1'
      } else {
        if (null === '1') console.log('chacheFirsteffectiveNetwork', '0')
        return  cacheFirst = '0'
      }
    }

    if (effectiveNetwork || settedNetwork === '0') {
      const resultNetworkCache = chacheFirstNetwork(effectiveNetwork, settedNetwork)
    }
   

    const cachedResponse = await cacheMatch(e.request)
    const response = await fetch(e.request)
  

    if (null === '1') {
      if (e.request.url.match(/\.(jpe?g|png|gif|svg|webp)$/)
        && response.url.includes('administrator') === false) {
        const reqUrl = new Request(e.request.url, { mode: 'no-cors' })
        const cache = await self.caches.open(imgCacheName)
        fetch(reqUrl).then(response => cache.put(reqUrl, response));
      }
    }

    if (response.ok) {   
      if (e.request.headers.get('Accept').includes('text/html')
        && response.url.includes('administrator') === false) {

         await uriExceptions(response.url, response)
          const cache = await self.caches.open(pageCacheName)
          if(e.request)
          cache.put(e.request, response.clone())
      }


     if (response.url.match(/\.(jpe?g|png|gif|svg|webp)$/)
        && response.url.includes('administrator') === false){
         const cache = await self.caches.open(imgCacheName)
         if(e.request.method !== 'DELETE') {
          cache.put(e.request, response.clone())
         } else {
          cache.delete(response.url)
         }
     
      }

      if (e.request.url.match(/\.(woff|eot|woff2|ttf)$/) 
        && response.url.includes('administrator') === false) {
        if (null === '1') console.log('Webfont Request ✏️', e.request.url)
        if (e.request.url.includes('gstatic') || e.request.url.includes('api')) {
          const reqUrlGoogle = new Request(e.request.url)
          const cache = await self.caches.open(webfontCacheName)
          fetch(reqUrlGoogle).then(response => cache.put(reqUrlGoogle, response));
        }
        
        const cache = await self.caches.open(webfontCacheName)
        if (null === '1') console.log('Intern-Font', e.request)
        cache.put(e.request, response.clone())
      }

    }
    
    if (cachedResponse && cacheFirst === '1') {
      if (null === '1') console.log('🗃 📲 Cache First (PWA)')
      if (null === '1') console.log('Response from Cache 🗃',cachedResponse, )
      return cachedResponse

    } else {
      if (null === '1') console.log('📡 📲 Network First (PWA)')
      return response

    } 
  } catch (error) {
    console.log('EM',error.message)
    if (error.message === 'uriException') {
      const response = await fetch(e.request)
      return response
    } 
  
    try {
       const responseFromCache = await cacheMatch(e.request)
        if (responseFromCache){
        return responseFromCache
      } else {
          return caches.match('/plugins/system/mittpwa/offline.html')
      }
    } catch (error){
      return caches.match('/plugins/system/mittpwa/offline.html')
    }
  }
}


self.addEventListener('install', e => {
  try {
    self.skipWaiting()
    e.waitUntil(
    cacheFiles()
    )
    console.log(`🛠PWA - ServiceWorker ⚙️ install ✅`)
  } catch {
    throw new Error('🛠 PWA Install Error 🚫 ', e)
  }
})

self.addEventListener('activate', e => {
  e.waitUntil(cleanCacheVersion())
})

self.addEventListener('fetch', e => {
  e.respondWith(
  respondTo(e))
})


const checkConnection = async _ => {
  if ('connection' in navigator) {
    const network = await navigator.connection.type
    const connection = await navigator.connection.effectiveType
    console.log('connection', connection)
    if (network === 'wifi' || connection === '4g') return true
  }
}

const checkStoragePersist = async _ => {
  if (navigator.storage && navigator.storage.persist) {
    const isPersisted = await navigator.storage.persist();
    return isPersisted
  }
}

const checkStorageAvailable = async _ => {
  if(navigator.storage && navigator.storage.estimate) {
    const quota = await navigator.storage.estimate();
    const percentageUsed = (quota.usage / quota.quota) * 100;
    if (null === '1') console.log(`You've used ${percentageUsed}% of the available storage.`);
    return percentageUsed
  }
}

const syncPages = async e => {
  if (null === '1') console.log('Periodic Sync is running')

  const connectionQuality = await checkConnection()
  if (!connectionQuality) return

  const storageMount = await checkStorageAvailable() 
  if (storageMount > 80) return
 
  try {
    const pageUrls = []
    for (const url of pageUrls) {
      const response = await fetch(url)
      const cache = await self.caches.open(pageCacheName)
      cache.add(url, response.clone())
    }
  } catch(e){
    console.log('errorSyncPage', e)
  }
}

const syncImages = async e => {
  if (null === '1') console.log('Periodic Sync is running')

  const connectionQuality = await checkConnection()
  if (!connectionQuality) return

  const storageMount = await checkStorageAvailable()
  if (storageMount > 80) return
  
  try {
    const imageUrls = []

    for (const url of imageUrls) {
      const response = await fetch(url)
      const cache = await self.caches.open(imgCacheName)
      cache.add(url, response.clone())
    }
  } catch (e) {
    console.log('errorSyncImg', e)
  }
}

self.addEventListener('periodicsync', e => {
  if (e.tag === 'page-sync') {
    e.waitUntil(syncPages(e))
  }

  if (e.tag === 'image-sync') {
    e.waitUntil(syncImages(e))
  }
})

self.addEventListener('message', (event) => {
  const isARefresh = (event) => event.data.message === 'refresh'

  const sendRefreshCompletedMessageToClient = (event) => event.ports[0].postMessage({refreshCompleted: true})

  if (isARefresh(event)) {   
    if (navigator.onLine) cleanCacheVersion()
    sendRefreshCompletedMessageToClient(event)
  }
})




